"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from gusto_app_integration.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class EmployeeWorkAddressTypedDict(TypedDict):
    r"""List of employee work addresses"""

    uuid: str
    r"""The unique identifier of this work address."""
    version: str
    r"""The current version of the object. See the [versioning guide](https://docs.gusto.com/embedded-payroll/docs/idempotency) for information on how to use this field."""
    effective_date: NotRequired[str]
    r"""The date the employee began working at this location."""
    active: NotRequired[bool]
    r"""Signifies if this address is the active work address for the current date"""
    location_uuid: NotRequired[str]
    r"""UUID reference to the company location for this work address."""
    employee_uuid: NotRequired[str]
    r"""UUID reference to the employee for this work address."""
    street_1: NotRequired[str]
    street_2: NotRequired[Nullable[str]]
    city: NotRequired[str]
    state: NotRequired[str]
    zip: NotRequired[str]
    country: NotRequired[str]


class EmployeeWorkAddress(BaseModel):
    r"""List of employee work addresses"""

    uuid: str
    r"""The unique identifier of this work address."""

    version: str
    r"""The current version of the object. See the [versioning guide](https://docs.gusto.com/embedded-payroll/docs/idempotency) for information on how to use this field."""

    effective_date: Optional[str] = None
    r"""The date the employee began working at this location."""

    active: Optional[bool] = None
    r"""Signifies if this address is the active work address for the current date"""

    location_uuid: Optional[str] = None
    r"""UUID reference to the company location for this work address."""

    employee_uuid: Optional[str] = None
    r"""UUID reference to the employee for this work address."""

    street_1: Optional[str] = None

    street_2: OptionalNullable[str] = UNSET

    city: Optional[str] = None

    state: Optional[str] = None

    zip: Optional[str] = None

    country: Optional[str] = "USA"

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "effective_date",
            "active",
            "location_uuid",
            "employee_uuid",
            "street_1",
            "street_2",
            "city",
            "state",
            "zip",
            "country",
        ]
        nullable_fields = ["street_2"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
