"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .versionheader import VersionHeader
from enum import Enum
from gusto_app_integration.types import BaseModel
from gusto_app_integration.utils import (
    FieldMetadata,
    HeaderMetadata,
    PathParamMetadata,
    QueryParamMetadata,
)
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class QueryParamInclude(str, Enum):
    ALL_COMPENSATIONS = "all_compensations"
    CUSTOM_FIELDS = "custom_fields"


class GetV1EmployeesRequestTypedDict(TypedDict):
    employee_id: str
    r"""The UUID of the employee"""
    include: NotRequired[List[QueryParamInclude]]
    r"""Include the requested attribute(s) in each employee response, multiple options are comma separated. Available options:
    - all_compensations: Include all effective dated compensations for each job instead of only the current compensation
    - custom_fields: Include employees' custom fields
    """
    x_gusto_api_version: NotRequired[VersionHeader]
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""


class GetV1EmployeesRequest(BaseModel):
    employee_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The UUID of the employee"""

    include: Annotated[
        Optional[List[QueryParamInclude]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=False)),
    ] = None
    r"""Include the requested attribute(s) in each employee response, multiple options are comma separated. Available options:
    - all_compensations: Include all effective dated compensations for each job instead of only the current compensation
    - custom_fields: Include employees' custom fields
    """

    x_gusto_api_version: Annotated[
        Optional[VersionHeader],
        pydantic.Field(alias="X-Gusto-API-Version"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = VersionHeader.TWO_THOUSAND_AND_TWENTY_FOUR_MINUS_04_MINUS_01
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""
