"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .versionheader import VersionHeader
from gusto_app_integration.types import BaseModel
from gusto_app_integration.utils import (
    FieldMetadata,
    HeaderMetadata,
    PathParamMetadata,
    RequestMetadata,
)
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PutRemovePeopleFromDepartmentEmployeesTypedDict(TypedDict):
    uuid: NotRequired[str]


class PutRemovePeopleFromDepartmentEmployees(BaseModel):
    uuid: Optional[str] = None


class PutRemovePeopleFromDepartmentContractorsTypedDict(TypedDict):
    uuid: NotRequired[str]


class PutRemovePeopleFromDepartmentContractors(BaseModel):
    uuid: Optional[str] = None


class PutRemovePeopleFromDepartmentRequestBodyTypedDict(TypedDict):
    version: NotRequired[str]
    r"""The current version of the object. See the [versioning guide](https://docs.gusto.com/embedded-payroll/docs/versioning#object-layer) for information on how to use this field."""
    employees: NotRequired[List[PutRemovePeopleFromDepartmentEmployeesTypedDict]]
    r"""Array of employees to remove from a department"""
    contractors: NotRequired[List[PutRemovePeopleFromDepartmentContractorsTypedDict]]
    r"""Array of contractors to remove from a department"""


class PutRemovePeopleFromDepartmentRequestBody(BaseModel):
    version: Optional[str] = None
    r"""The current version of the object. See the [versioning guide](https://docs.gusto.com/embedded-payroll/docs/versioning#object-layer) for information on how to use this field."""

    employees: Optional[List[PutRemovePeopleFromDepartmentEmployees]] = None
    r"""Array of employees to remove from a department"""

    contractors: Optional[List[PutRemovePeopleFromDepartmentContractors]] = None
    r"""Array of contractors to remove from a department"""


class PutRemovePeopleFromDepartmentRequestTypedDict(TypedDict):
    department_uuid: str
    r"""The UUID of the department"""
    request_body: PutRemovePeopleFromDepartmentRequestBodyTypedDict
    x_gusto_api_version: NotRequired[VersionHeader]
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""


class PutRemovePeopleFromDepartmentRequest(BaseModel):
    department_uuid: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The UUID of the department"""

    request_body: Annotated[
        PutRemovePeopleFromDepartmentRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    x_gusto_api_version: Annotated[
        Optional[VersionHeader],
        pydantic.Field(alias="X-Gusto-API-Version"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = VersionHeader.TWO_THOUSAND_AND_TWENTY_FOUR_MINUS_04_MINUS_01
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""
