"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .versionheader import VersionHeader
from gusto_app_integration.types import BaseModel
from gusto_app_integration.utils import (
    FieldMetadata,
    HeaderMetadata,
    PathParamMetadata,
    RequestMetadata,
    SecurityMetadata,
)
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PutV1VerifyWebhookSubscriptionUUIDSecurityTypedDict(TypedDict):
    system_access_auth: str


class PutV1VerifyWebhookSubscriptionUUIDSecurity(BaseModel):
    system_access_auth: Annotated[
        str,
        FieldMetadata(
            security=SecurityMetadata(
                scheme=True,
                scheme_type="http",
                sub_type="bearer",
                field_name="Authorization",
            )
        ),
    ]


class PutV1VerifyWebhookSubscriptionUUIDRequestBodyTypedDict(TypedDict):
    verification_token: str
    r"""The token POSTed to the Subscription URL."""


class PutV1VerifyWebhookSubscriptionUUIDRequestBody(BaseModel):
    verification_token: str
    r"""The token POSTed to the Subscription URL."""


class PutV1VerifyWebhookSubscriptionUUIDRequestTypedDict(TypedDict):
    webhook_subscription_uuid: str
    r"""The webhook subscription UUID."""
    request_body: PutV1VerifyWebhookSubscriptionUUIDRequestBodyTypedDict
    x_gusto_api_version: NotRequired[VersionHeader]
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""


class PutV1VerifyWebhookSubscriptionUUIDRequest(BaseModel):
    webhook_subscription_uuid: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The webhook subscription UUID."""

    request_body: Annotated[
        PutV1VerifyWebhookSubscriptionUUIDRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    x_gusto_api_version: Annotated[
        Optional[VersionHeader],
        pydantic.Field(alias="X-Gusto-API-Version"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = VersionHeader.TWO_THOUSAND_AND_TWENTY_FOUR_MINUS_04_MINUS_01
    r"""Determines the date-based API version associated with your API call. If none is provided, your application's [minimum API version](https://docs.gusto.com/embedded-payroll/docs/api-versioning#minimum-api-version) is used."""
