"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from gusto_app_integration.types import BaseModel
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class EmploymentStatus(str, Enum):
    r"""The employee's employment status. Supplying an invalid option will set the employment_status to *not_set*."""

    PART_TIME = "part_time"
    FULL_TIME = "full_time"
    PART_TIME_ELIGIBLE = "part_time_eligible"
    VARIABLE = "variable"
    SEASONAL = "seasonal"
    NOT_SET = "not_set"


class RehireBodyTypedDict(TypedDict):
    effective_date: str
    r"""The day when the employee returns to work."""
    file_new_hire_report: bool
    r"""The boolean flag indicating whether Gusto will file a new hire report for the employee."""
    work_location_uuid: str
    r"""The uuid of the employee's work location."""
    employment_status: NotRequired[EmploymentStatus]
    r"""The employee's employment status. Supplying an invalid option will set the employment_status to *not_set*."""
    two_percent_shareholder: NotRequired[bool]
    r"""Whether the employee is a two percent shareholder of the company. This field only applies to companies with an S-Corp entity type."""


class RehireBody(BaseModel):
    effective_date: str
    r"""The day when the employee returns to work."""

    file_new_hire_report: bool
    r"""The boolean flag indicating whether Gusto will file a new hire report for the employee."""

    work_location_uuid: str
    r"""The uuid of the employee's work location."""

    employment_status: Optional[EmploymentStatus] = None
    r"""The employee's employment status. Supplying an invalid option will set the employment_status to *not_set*."""

    two_percent_shareholder: Optional[bool] = None
    r"""Whether the employee is a two percent shareholder of the company. This field only applies to companies with an S-Corp entity type."""
